package RVVote::GraphAPI;

use strict;
use warnings;
use utf8;
use Mojo::UserAgent;

our $VERSION = '0.01';

sub new {
    my $classname = shift;
    my $base_url  = shift;
    my $self      = {};

    $self->{ua} = Mojo::UserAgent->new();
    $self->{base_url} = $base_url;

    bless ($self, $classname);
    return $self;
}

sub ua {
    my $self = shift;
    return $self->{ua};
}

sub get_group_members {
    my $self     = shift;
    my $group_id = shift;

    my $res = $self->ua->get( join '/', (
        $self->{base_url},
        $group_id,
        'members'
    ))->result();

    return undef if ! $res->is_success;    
    return undef if ! ref $res->json eq 'ARRAY';

    my @members = ();

    MEMBER:
    foreach my $member ( @{ $res->json } ) {
        my $res2 = $self->ua->get( join '/', (
            $self->{base_url},
            'user',
            $member->{username_clean},
        ))->result();
        next MEMBER if ! $res2->is_success;    
        next MEMBER if ! ref $res2->json eq 'ARRAY';

        $member = $res2->json;
        (undef, $member->{lastname}) = split /\W+/, $member->{username_clean}              
        push @members, $member;
    }

    return sort { $a->{lastname} le $b->{lastname} } @members;

};
